diff -ruN ../nakedmudv2.7/src/scripts/trigedit.c src/scripts/trigedit.c
--- ../nakedmudv2.7/src/scripts/trigedit.c	Wed Dec 31 17:00:00 1969
+++ src/scripts/trigedit.c	Fri Oct  7 14:15:55 2005
@@ -0,0 +1,223 @@
+//*****************************************************************************
+//
+// trigedit.c
+//
+// contains the functions neccessary for using OLC on triggers.
+//
+//*****************************************************************************
+#include "../mud.h"
+#include "../socket.h"
+#include "../character.h"
+#include "../utils.h"
+#include "../world.h"
+#include "scripts.h"
+
+
+
+//*****************************************************************************
+// mandatory modules
+//*****************************************************************************
+#include "../editor/editor.h"
+#include "script_editor.h"
+
+#ifdef MODULE_OLC2
+#include "../olc2/olc.h"
+
+
+
+//*****************************************************************************
+// trigger lists
+//*****************************************************************************
+#define TRIGLIST_NEW     1
+#define TRIGLIST_DELETE  2
+
+void trigger_list_menu(SOCKET_DATA *sock, LIST *triggers) {
+  if(listSize(triggers) > 0) {
+    send_to_socket(sock, "{wCurrent triggers:\r\n");
+    LIST_ITERATOR *trig_i = newListIterator(triggers);
+    char            *trig = NULL;
+    ITERATE_LIST(trig, trig_i) {
+      send_to_socket(sock, "  {g%s\r\n", trig);
+    } deleteListIterator(trig_i);
+  }
+
+  send_to_socket(sock, 
+		 "\r\n"
+		 "  {gN) Add new trigger\r\n"
+		 "  {gD) Delete trigger\r\n");
+}
+
+int trigger_list_chooser(SOCKET_DATA *sock, LIST *triggers, const char *option){
+  switch(toupper(*option)) {
+  case 'N':
+    send_to_socket(sock, "Enter key for trigger to attach: ");
+    return TRIGLIST_NEW;
+  case 'D':
+    send_to_socket(sock, "Enter key for trigger to delete: ");
+    return TRIGLIST_DELETE;
+  default: 
+    return MENU_CHOICE_INVALID;
+  }
+}
+
+bool trigger_list_parser(SOCKET_DATA *sock, LIST *triggers, int choice,
+		    const char *arg) {
+  switch(choice) {
+  case TRIGLIST_NEW:
+    if(!listGetWith(triggers, arg, strcasecmp))
+      listPutWith(triggers, strdup(arg), strcasecmp);
+    return TRUE;
+  case TRIGLIST_DELETE: {
+    char *found = listRemoveWith(triggers, arg, strcasecmp);
+    if(found) free(found);
+    return TRUE;
+  }
+  default: return FALSE;
+  }
+}
+
+
+
+//*****************************************************************************
+// triggers
+//*****************************************************************************
+#define TEDIT_NAME       1
+#define TEDIT_TYPE       2
+
+struct trigger_type_usable_list {
+  char    *type;
+  char *used_by;
+};
+
+// a table of allowable trigger types
+struct trigger_type_usable_list trigger_types[] = {
+  { "speech",  "mob, room" },
+  { "greet",   "mob"       },
+  { "enter",   "mob, room" },
+  { "exit",    "mob, room" },
+  { "move",    "mob"       },
+  { "drop",    "obj, room" },
+  { "get",     "obj, room" },
+  { "give",    "obj, mob"  },
+  { "receive", "mob"       },
+  { "wear",    "mob"       },
+  { "remove",  "obj, mob"  },
+  { "reset",   "room"      },
+  { "", "" },
+};
+
+int num_trig_types(void) {
+  static int num = -1;
+  // we need to calculate...
+  if(num == -1)
+    do { num++; } while(*trigger_types[num].type);
+  return num;
+}
+
+// returns the trigger type name, for the given number
+const char *triggerTypeGetName(int num) {
+  return trigger_types[num].type;
+}
+
+// returns the types of things the trigger can be attached to
+const char *triggerTypeGetUsedBy(int num) {
+  return trigger_types[num].used_by;
+}
+
+// returns a buffer that contains the name and used-by list for a trigger
+const char *triggerTypeGetNameAndUsedBy(int num) {
+  static char buf[100];
+  sprintf(buf, "%-20s %s", triggerTypeGetName(num), triggerTypeGetUsedBy(num));
+  return buf;
+}
+
+void tedit_menu(SOCKET_DATA *sock, TRIGGER_DATA *trigger) {
+  send_to_socket(sock,
+		 "{g[{c%s{g]\r\n"
+		 "{g1) Name        : {c%s\r\n"
+		 "{g2) Trigger type: {c%s\r\n"
+		 "{g3) Script Code\r\n",
+		 triggerGetKey(trigger),
+		 triggerGetName(trigger),
+		 (*triggerGetType(trigger) ? triggerGetType(trigger):"<NONE>"));
+  script_display(sock, triggerGetCode(trigger), FALSE);
+}
+
+int tedit_chooser(SOCKET_DATA *sock, TRIGGER_DATA *trigger, const char *option){
+  switch(toupper(*option)) {
+  case '1':
+    send_to_socket(sock, "Enter trigger name: ");
+    return TEDIT_NAME;
+  case '2':
+    send_to_socket(sock, "      {wType                 Usable By\r\n");
+    send_to_socket(sock, "      {y-----------------------------------\r\n");
+    olc_display_table(sock, triggerTypeGetNameAndUsedBy, num_trig_types(), 1);
+    send_to_socket(sock, "\r\nEnter trigger type: ");
+    return TEDIT_TYPE;
+  case '3':
+    socketStartEditor(sock, script_editor, triggerGetCodeBuffer(trigger));
+    return MENU_NOCHOICE;
+  default:
+    return MENU_CHOICE_INVALID;
+  }
+}
+
+bool tedit_parser(SOCKET_DATA *sock, TRIGGER_DATA *trigger, int choice,
+		  const char *arg) {
+  switch(choice) {
+  case TEDIT_NAME:
+    triggerSetName(trigger, arg);
+    return TRUE;
+
+  case TEDIT_TYPE: {
+    int num = atoi(arg);
+    if(num < 0 || num >= num_trig_types())
+      return FALSE;
+    else {
+      triggerSetType(trigger, triggerTypeGetName(num));
+      return TRUE;
+    }
+  }
+
+  default: 
+    return FALSE;
+  }
+}
+
+void save_trigger(TRIGGER_DATA *trigger) {
+  worldSaveType(gameworld, "trigger", triggerGetKey(trigger));
+}
+
+COMMAND(cmd_tedit) {
+  ZONE_DATA       *zone = NULL;
+  TRIGGER_DATA *trigger = NULL;
+
+  // we need a key
+  if(!arg || !*arg)
+    send_to_char(ch,"Please supply the key of a trigger you wish to edit.\r\n");
+  else {
+    char name[SMALL_BUFFER], locale[SMALL_BUFFER];
+    if(!parse_worldkey_relative(ch, arg, name, locale))
+      send_to_char(ch, "Which trigger are you trying to edit?\r\n");
+    else if( (zone = worldGetZone(gameworld, locale)) == NULL)
+      send_to_char(ch, "No such zone exists.\r\n");
+    else if(!canEditZone(zone, ch))
+      send_to_char(ch, "You are not authorized to edit that zone.\r\n");
+    else {
+      // pull up the script
+      trigger = worldGetType(gameworld, "trigger", get_fullkey(name, locale));
+      if(trigger == NULL) {
+	trigger = newTrigger();
+	triggerSetName(trigger, "An Unfinished Trigger");
+	triggerSetCode(trigger, "# trigger code goes here\n"
+		                "# make sure to comment it with pounds (#)\n");
+	worldPutType(gameworld, "trigger", get_fullkey(name, locale), trigger);
+      }
+
+      do_olc(charGetSocket(ch), tedit_menu, tedit_chooser, tedit_parser,
+	     triggerCopy, triggerCopyTo, deleteTrigger, save_trigger, trigger);
+    }
+  }
+}
+
+#endif // MODULE_OLC2
diff -ruN ../nakedmudv2.7/src/scripts/triggers.c src/scripts/triggers.c
--- ../nakedmudv2.7/src/scripts/triggers.c	Wed Dec 31 17:00:00 1969
+++ src/scripts/triggers.c	Fri Oct  7 14:15:55 2005
@@ -0,0 +1,115 @@
+//*****************************************************************************
+//
+// triggers.c
+//
+// contains all of the functions for working with triggers. This has been
+// separated off from scripts.c to keep things a bit more tidy.
+//
+//*****************************************************************************
+
+#include "../mud.h"
+#include "../utils.h"
+#include "../storage.h"
+
+#include "scripts.h"
+
+
+
+//*****************************************************************************
+// local datastructures, functions, and defines
+//*****************************************************************************
+struct trigger_data {
+  char   *name; // a short description of what the trigger is intended for
+  char   *type; // what type of hook does this trigger install itself as?
+  char    *key; // our unique key for lookup in the world database
+  BUFFER *code; // the python script that is executed
+};
+
+
+
+//*****************************************************************************
+// implementation of triggers
+//*****************************************************************************
+TRIGGER_DATA  *newTrigger(void) {
+  TRIGGER_DATA *data = malloc(sizeof(TRIGGER_DATA));
+  data->name         = strdup("");
+  data->type         = strdup("");
+  data->key          = strdup("");
+  data->code         = newBuffer(1);
+  return data;
+}
+
+void deleteTrigger(TRIGGER_DATA *trigger) {
+  if(trigger->name) free(trigger->name);
+  if(trigger->type) free(trigger->type);
+  if(trigger->key)  free(trigger->key);
+}
+
+STORAGE_SET *triggerStore(TRIGGER_DATA *trigger) {
+  STORAGE_SET *set = new_storage_set();
+  store_string(set, "name", trigger->name);
+  store_string(set, "type", trigger->type);
+  store_string(set, "code", bufferString(trigger->code));
+  return set;
+}
+
+TRIGGER_DATA *triggerRead(STORAGE_SET *set) {
+  TRIGGER_DATA *trigger = newTrigger();
+  triggerSetName(trigger, read_string(set, "name"));
+  triggerSetType(trigger, read_string(set, "type"));
+  triggerSetCode(trigger, read_string(set, "code"));
+  return trigger;
+}
+
+void triggerCopyTo(TRIGGER_DATA *from, TRIGGER_DATA *to) {
+  triggerSetKey (to, triggerGetKey (from));
+  triggerSetName(to, triggerGetName(from));
+  triggerSetType(to, triggerGetType(from));
+  triggerSetCode(to, triggerGetCode(from));
+}
+
+TRIGGER_DATA *triggerCopy(TRIGGER_DATA *trigger) {
+  TRIGGER_DATA *newtrigger = newTrigger();
+  triggerCopyTo(trigger, newtrigger);
+  return newtrigger;
+}
+
+void triggerSetName(TRIGGER_DATA *trigger, const char *name) {
+  if(trigger->name) free(trigger->name);
+  trigger->name = strdupsafe(name);
+}
+
+void triggerSetType(TRIGGER_DATA *trigger, const char *type) {
+  if(trigger->type) free(trigger->type);
+  trigger->type = strdupsafe(type);
+}
+
+void triggerSetKey(TRIGGER_DATA *trigger, const char *key) {
+  if(trigger->key) free(trigger->key);
+  trigger->key = strdupsafe(key);
+}
+
+void triggerSetCode(TRIGGER_DATA *trigger, const char *code) {
+  bufferClear(trigger->code);
+  bufferCat(trigger->code, code);
+}
+
+const char *triggerGetName(TRIGGER_DATA *trigger) {
+  return trigger->name;
+}
+
+const char *triggerGetType(TRIGGER_DATA *trigger) {
+  return trigger->type;
+}
+
+const char *triggerGetKey(TRIGGER_DATA *trigger) {
+  return trigger->key;
+}
+
+const char *triggerGetCode(TRIGGER_DATA *trigger) {
+  return bufferString(trigger->code);
+}
+
+BUFFER *triggerGetCodeBuffer(TRIGGER_DATA *trigger) {
+  return trigger->code;
+}
diff -ruN ../nakedmudv2.7/src/scripts/trighooks.c src/scripts/trighooks.c
--- ../nakedmudv2.7/src/scripts/trighooks.c	Wed Dec 31 17:00:00 1969
+++ src/scripts/trighooks.c	Fri Oct  7 14:15:55 2005
@@ -0,0 +1,378 @@
+//*****************************************************************************
+//
+// trighooks.c
+//
+// Triggers attach on to rooms, objects, and mobiles as hooks. When a hook
+// event occurs, all of the triggers of the right type will run. This header is
+// just to allow scripts to initialize the hooks into the game. The init 
+// function here should not be touched by anything other than scripts.c
+//
+//*****************************************************************************
+
+#include "../mud.h"
+#include "../utils.h"
+#include "../hooks.h"
+#include "../character.h"
+#include "../room.h"
+#include "../object.h"
+#include "../world.h"
+#include "../zone.h"
+
+#include "scripts.h"
+#include "pychar.h"
+#include "pyobj.h"
+#include "pyroom.h"
+#include "pyexit.h"
+
+
+
+//*****************************************************************************
+// local datastructures and defines
+//*****************************************************************************
+
+// values for figuring out what "me" and optional variables are in gen_do_trig
+#define VARTYPE_CHAR      0
+#define VARTYPE_OBJ       1
+#define VARTYPE_ROOM      2
+
+// used for providing additional variables to gen_do_trig that are not standard
+typedef struct {
+  char *name;
+  void *data;
+  int   type;
+} OPT_VAR;
+
+OPT_VAR *newOptVar(const char *name, void *data, int type) {
+  OPT_VAR *var = malloc(sizeof(OPT_VAR));
+  var->name    = strdupsafe(name);
+  var->data    = data;
+  var->type    = type;
+  return var;
+}
+
+void deleteOptVar(OPT_VAR *var) {
+  if(var->name) free(var->name);
+  free(var);
+}
+
+
+
+//*****************************************************************************
+// trigger handlers
+//*****************************************************************************
+
+//
+// generalized function for setting up a dictionary and running a trigger. The
+// common types of variables can be supplied in the function. Additional ones
+// can be added in the optional list, which must be deleted after use
+void gen_do_trig(TRIGGER_DATA *trig, 
+		 void *me, int me_type, CHAR_DATA *ch, OBJ_DATA *obj,
+		 ROOM_DATA *room, EXIT_DATA *exit, const char *command,
+		 const char *arg, LIST *optional) {
+  // make our basic dictionary, and fill it up with these new variables
+  PyObject *dict = restricted_script_dict();
+  // now, import all of our variables
+  if(command) {
+    PyObject *pycmd = PyString_FromString(command);
+    PyDict_SetItemString(dict, "cmd", pycmd);
+    Py_DECREF(pycmd);
+  }
+  if(arg) {
+    PyObject *pyarg = PyString_FromString(arg);
+    PyDict_SetItemString(dict, "arg", pyarg);
+    Py_DECREF(pyarg);
+  }
+  if(ch) {
+    PyObject *pych = newPyChar(ch);
+    PyDict_SetItemString(dict, "ch", pych);
+    Py_DECREF(pych);
+  }
+  if(room) {
+    PyObject *pyroom = newPyRoom(room);
+    PyDict_SetItemString(dict, "room", pyroom);
+    Py_DECREF(pyroom);
+  }    
+  if(obj) {
+    PyObject *pyobj = newPyObj(obj);
+    PyDict_SetItemString(dict, "obj", pyobj);
+    Py_DECREF(pyobj);
+  }
+  if(exit) {
+    PyObject *pyexit = newPyExit(exit);
+    PyDict_SetItemString(dict, "ex", pyexit);
+    Py_DECREF(pyexit);
+  }
+
+  // add the thing the tirgger is attached to
+  if(me) {
+    PyObject *pyme = NULL;
+    switch(me_type) {
+    case VARTYPE_CHAR:  pyme = newPyChar(me); break;
+    case VARTYPE_OBJ:   pyme = newPyObj(me);  break;
+    case VARTYPE_ROOM:  pyme = newPyRoom(me); break;
+    }
+    PyDict_SetItemString(dict, "me", pyme);
+    Py_DECREF(pyme);
+  }
+
+  // now, add any optional variables
+  if(optional) {
+    LIST_ITERATOR *opt_i = newListIterator(optional);
+    OPT_VAR         *opt = NULL;
+    PyObject      *pyopt = NULL;
+    ITERATE_LIST(opt, opt_i) {
+      pyopt = NULL;
+      switch(opt->type) {
+      case VARTYPE_CHAR:  pyopt = newPyChar(opt->data); break;
+      case VARTYPE_OBJ:   pyopt = newPyObj(opt->data);  break;
+      case VARTYPE_ROOM:  pyopt = newPyRoom(opt->data); break;
+      }
+      PyDict_SetItemString(dict, opt->name, pyopt);
+      Py_XDECREF(pyopt);
+    } deleteListIterator(opt_i);
+  }
+
+  // run the script, then kill our dictionary
+  run_script(dict, triggerGetCode(trig), get_key_locale(triggerGetKey(trig)));
+  Py_DECREF(dict);
+}
+
+
+//
+// handles all of a character's triggers
+void do_char_trigs(CHAR_DATA *ch, const char *type, void *thing, void *arg) {
+  if(listSize(charGetTriggers(ch)) > 0) {
+    // first, build a list of all our triggers of this type
+    LIST           *trigs = newList();
+    LIST_ITERATOR *trig_i = newListIterator(charGetTriggers(ch));
+    char             *key = NULL;
+    TRIGGER_DATA    *trig = NULL;
+    ITERATE_LIST(key, trig_i) {
+      if((trig = worldGetType(gameworld, "trigger", key)) != NULL &&
+	 !strcasecmp(triggerGetType(trig), type))
+	listPut(trigs, trig);
+    } deleteListIterator(trig_i);
+
+    // did we find any triggers?
+    if(listSize(trigs) > 0) {
+      trig_i = newListIterator(trigs);
+      ITERATE_LIST(trig, trig_i) {
+	if(!strcasecmp(type, "speech"))
+	  gen_do_trig(trig,ch,VARTYPE_CHAR,thing,NULL,NULL,NULL,NULL,arg,NULL);
+	else if(!strcasecmp(type, "move"))
+	  gen_do_trig(trig,ch,VARTYPE_CHAR,NULL,NULL,NULL,thing,NULL,NULL,NULL);
+	else if(!strcasecmp(type, "enter"))
+	  gen_do_trig(trig,ch,VARTYPE_CHAR,thing,NULL,NULL,NULL,NULL,NULL,NULL);
+	else if(!strcasecmp(type, "exit"))
+	  gen_do_trig(trig,ch,VARTYPE_CHAR,thing,NULL,NULL,arg,NULL,NULL,NULL);
+	else if(!strcasecmp(type, "greet"))
+	  gen_do_trig(trig,ch,VARTYPE_CHAR,thing,NULL,NULL,NULL,NULL,NULL,NULL);
+	else if(!strcasecmp(type, "give"))
+	  gen_do_trig(trig,ch,VARTYPE_CHAR,thing,arg,NULL,NULL,NULL,NULL,NULL);
+	else if(!strcasecmp(type, "receive"))
+	  gen_do_trig(trig,ch,VARTYPE_CHAR,thing,arg,NULL,NULL,NULL,NULL,NULL);
+	else if(!strcasecmp(type, "wear"))
+	  gen_do_trig(trig,ch,VARTYPE_CHAR,NULL,thing,NULL,NULL,NULL,NULL,NULL);
+	else if(!strcasecmp(type, "remove"))
+	  gen_do_trig(trig,ch,VARTYPE_CHAR,NULL,thing,NULL,NULL,NULL,NULL,NULL);
+	else {
+	  log_string("Unrecognized trigger type %s attached to %s, uid %d.\r\n",
+		     type, charGetClass(ch), charGetUID(ch));
+	}
+      } deleteListIterator(trig_i);
+    }
+    
+    // clean up our mess
+    deleteList(trigs);
+  }
+}
+
+//
+// handles all of an object's triggers
+void do_obj_trigs(OBJ_DATA *obj, const char *type, void *thing, void *arg) {
+  if(listSize(objGetTriggers(obj)) > 0) {
+    // first, build a list of all our triggers of this type
+    LIST           *trigs = newList();
+    LIST_ITERATOR *trig_i = newListIterator(objGetTriggers(obj));
+    char             *key = NULL;
+    TRIGGER_DATA    *trig = NULL;
+    ITERATE_LIST(key, trig_i) {
+      if((trig = worldGetType(gameworld, "trigger", key)) != NULL &&
+	 !strcasecmp(triggerGetType(trig), type))
+	listPut(trigs, trig);
+    } deleteListIterator(trig_i);
+
+    // did we find any triggers?
+    if(listSize(trigs) > 0) {
+      trig_i = newListIterator(trigs);
+      ITERATE_LIST(trig, trig_i) {
+	if(!strcasecmp(type, "give")) {
+	  // set up the optional "receiver" variable
+	  LIST *opts = newList();
+	  listPut(opts, newOptVar("recv", arg, VARTYPE_CHAR));
+	  gen_do_trig(trig,obj,VARTYPE_OBJ,thing,NULL,NULL,NULL,NULL,NULL,opts);
+	  deleteListWith(opts, deleteOptVar);
+	}
+	else if(!strcasecmp(type, "get"))
+	  gen_do_trig(trig,obj,VARTYPE_OBJ,thing,NULL,NULL,NULL,NULL,NULL,NULL);
+	else if(!strcasecmp(type, "drop"))
+	  gen_do_trig(trig,obj,VARTYPE_OBJ,thing,NULL,NULL,NULL,NULL,NULL,NULL);
+	else if(!strcasecmp(type, "wear"))
+	  gen_do_trig(trig,obj,VARTYPE_OBJ,thing,NULL,NULL,NULL,NULL,NULL,NULL);
+	else if(!strcasecmp(type, "remove"))
+	  gen_do_trig(trig,obj,VARTYPE_OBJ,thing,NULL,NULL,NULL,NULL,NULL,NULL);
+	else {
+	  log_string("Unrecognized trigger type %s attached to %s, uid %d.\r\n",
+		     type, objGetClass(obj), objGetUID(obj));
+	}
+      } deleteListIterator(trig_i);
+    }
+
+    // clean up our mess
+    deleteList(trigs);
+  }
+}
+
+//
+// handles all of a room's triggers
+void do_room_trigs(ROOM_DATA *rm, const char *type, void *thing, void *arg){
+  if(listSize(roomGetTriggers(rm)) > 0) {
+    // first, build a list of all our triggers of this type
+    LIST           *trigs = newList();
+    LIST_ITERATOR *trig_i = newListIterator(roomGetTriggers(rm));
+    char             *key = NULL;
+    TRIGGER_DATA    *trig = NULL;
+    ITERATE_LIST(key, trig_i) {
+      if((trig = worldGetType(gameworld, "trigger", key)) != NULL &&
+	 !strcasecmp(triggerGetType(trig), type))
+	listPut(trigs, trig);
+    } deleteListIterator(trig_i);
+
+    // did we find any triggers?
+    if(listSize(trigs) > 0) {
+      trig_i = newListIterator(trigs);
+      ITERATE_LIST(trig, trig_i) {
+	if(!strcasecmp(type, "get"))
+	  gen_do_trig(trig,rm,VARTYPE_ROOM,thing,arg,NULL,NULL,NULL,NULL,NULL);
+	else if(!strcasecmp(type, "drop"))
+	  gen_do_trig(trig,rm,VARTYPE_ROOM,thing,arg,NULL,NULL,NULL,NULL,NULL);
+	else if(!strcasecmp(type, "enter"))
+	  gen_do_trig(trig,rm,VARTYPE_ROOM,thing,NULL,NULL,NULL,NULL,NULL,NULL);
+	else if(!strcasecmp(type, "exit"))
+	  gen_do_trig(trig,rm,VARTYPE_ROOM,thing,NULL,NULL,arg,NULL,NULL,NULL);
+	else if(!strcasecmp(type, "speech"))
+	  gen_do_trig(trig,rm,VARTYPE_ROOM,thing,NULL,NULL,NULL,NULL,arg,NULL);
+	else if(!strcasecmp(type, "reset"))
+	  gen_do_trig(trig,rm,VARTYPE_ROOM,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
+	else {
+	  log_string("Unrecognized trigger type %s attached to %s, uid %d.\r\n",
+		     type, roomGetClass(rm), roomGetUID(rm));
+	}
+      } deleteListIterator(trig_i);
+    }
+    
+    // clean up our mess
+    deleteList(trigs);
+  }
+}
+
+
+
+//*****************************************************************************
+// trighooks
+//*****************************************************************************
+void do_give_trighooks(CHAR_DATA *ch, CHAR_DATA *recv, OBJ_DATA *obj) {
+  do_char_trigs(ch,   "give",    recv, obj);
+  do_char_trigs(recv, "receive", ch,   obj);
+  do_obj_trigs (obj,  "give",    ch,  recv);
+}
+
+void do_get_trighooks(CHAR_DATA *ch, OBJ_DATA *obj, void *none) {
+  do_obj_trigs (obj,             "get", ch, NULL);
+  do_room_trigs(charGetRoom(ch), "get", ch, obj);
+}
+
+void do_drop_trighooks(CHAR_DATA *ch, OBJ_DATA *obj, void *none) {
+  do_obj_trigs (obj,             "drop", ch, NULL);
+  do_room_trigs(charGetRoom(ch), "drop", ch,  obj);
+}
+
+void do_enter_trighooks(CHAR_DATA *ch, ROOM_DATA *room, void *none) {
+  LIST_ITERATOR *mob_i = newListIterator(roomGetCharacters(room));
+  CHAR_DATA       *mob = NULL;
+  ITERATE_LIST(mob, mob_i) {
+    if(ch != mob)
+      do_char_trigs(mob, "enter", ch, NULL);
+  } deleteListIterator(mob_i);
+  do_room_trigs(room, "enter", ch, NULL);
+}
+
+void do_exit_trighooks(CHAR_DATA *ch, ROOM_DATA *room, EXIT_DATA *exit) {
+  LIST_ITERATOR *mob_i = newListIterator(roomGetCharacters(room));
+  CHAR_DATA       *mob = NULL;
+  ITERATE_LIST(mob, mob_i) {
+    if(ch != mob)
+      do_char_trigs(mob, "exit", ch, exit);
+  } deleteListIterator(mob_i);
+  do_room_trigs(room, "exit", ch,   exit);
+  do_char_trigs(ch,   "move", exit, NULL);
+}
+
+void do_ask_trighooks(CHAR_DATA *ch, CHAR_DATA *listener, char *speech) {
+  do_char_trigs(listener, "speech", ch, speech);
+}
+
+void do_say_trighooks(CHAR_DATA *ch, void *none, char *speech) {
+  LIST_ITERATOR *mob_i = newListIterator(roomGetCharacters(charGetRoom(ch)));
+  CHAR_DATA       *mob = NULL;
+  ITERATE_LIST(mob, mob_i) {
+    if(ch != mob)
+      do_char_trigs(mob, "speech", ch, speech);
+  } deleteListIterator(mob_i);
+  do_room_trigs(charGetRoom(ch), "speech", ch, speech);
+}
+
+void do_greet_trighooks(CHAR_DATA *ch, CHAR_DATA *greeted, void *none) {
+  do_char_trigs(greeted, "greet", ch, NULL);
+}
+
+void do_wear_trighooks(CHAR_DATA *ch, OBJ_DATA *obj, void *none) {
+  do_char_trigs(ch,  "wear", obj, NULL);
+  do_obj_trigs (obj, "wear", ch,  NULL);
+}
+
+void do_remove_trighooks(CHAR_DATA *ch, OBJ_DATA *obj, void *none) {
+  do_char_trigs(ch,  "remove", obj, NULL);
+  do_obj_trigs (obj, "remove", ch,  NULL);
+}
+
+void do_reset_trighooks(ZONE_DATA *zone, void *none1, void *none2) {
+  LIST_ITERATOR *res_i = newListIterator(zoneGetResettable(zone));
+  char           *name = NULL;
+  const char   *locale = zoneGetKey(zone);
+  ROOM_DATA      *room = NULL;
+  ITERATE_LIST(name, res_i) {
+    room = worldGetRoom(gameworld, get_fullkey(name, locale));
+    if(room != NULL) do_room_trigs(room, "reset", NULL, NULL);
+  } deleteListIterator(res_i);
+}
+
+
+
+//*****************************************************************************
+// implementation of trighooks.h
+//*****************************************************************************
+void init_trighooks(void) {
+  // add all of our hooks to the game
+  hookAdd("give",   do_give_trighooks);
+  hookAdd("get",    do_get_trighooks);
+  hookAdd("drop",   do_drop_trighooks);
+  hookAdd("enter",  do_enter_trighooks);
+  hookAdd("exit",   do_exit_trighooks);
+  hookAdd("ask",    do_ask_trighooks);
+  hookAdd("say",    do_say_trighooks);
+  hookAdd("greet",  do_greet_trighooks);
+  hookAdd("wear",   do_wear_trighooks);
+  hookAdd("remove", do_remove_trighooks);
+  hookAdd("reset",  do_reset_trighooks);
+}
diff -ruN ../nakedmudv2.7/src/scripts/trighooks.h src/scripts/trighooks.h
--- ../nakedmudv2.7/src/scripts/trighooks.h	Wed Dec 31 17:00:00 1969
+++ src/scripts/trighooks.h	Fri Oct  7 14:15:55 2005
@@ -0,0 +1,19 @@
+#ifndef TRIGHOOKS_H
+#define TRIGHOOKS_H
+//*****************************************************************************
+//
+// trighooks.h
+//
+// Triggers attach on to rooms, objects, and mobiles as hooks. When a hook
+// event occurs, all of the triggers of the right type will run. This header is
+// just to allow scripts to initialize the hooks into the game. The init 
+// function here should not be touched by anything other than scripts.c
+//
+//*****************************************************************************
+
+//
+// called when init_scripts() is run
+void init_trighooks(void);
+
+#endif // TRIGHOOKS_H
+
diff -ruN ../nakedmudv2.7/src/set_val/set_val.c src/set_val/set_val.c
--- ../nakedmudv2.7/src/set_val/set_val.c	Sun Jul 31 17:13:51 2005
+++ src/set_val/set_val.c	Fri Oct  7 14:15:55 2005
@@ -56,6 +56,7 @@
 HASHTABLE *char_set_table = NULL;
 HASHTABLE *obj_set_table  = NULL;
 HASHTABLE *room_set_table = NULL;
+HASHTABLE *acct_set_table = NULL;
 
 typedef struct set_val_data {
   int   type;    // the type of data (int, double, long, string, etc...)
@@ -116,10 +117,6 @@
 }
 
 
-// are we trying to set a value from an argument, or from our notepad?
-#define SET_SUBCMD_SET        0
-#define SET_SUBCMD_SETPAD     1
-
 //
 // The entrypoint to the set utility for players in the MUD
 //   usage: set [thing] [field] [value]
@@ -131,19 +128,26 @@
 COMMAND(cmd_set) {
   char name [SMALL_BUFFER];
   char field[SMALL_BUFFER];
-  bool  file = FALSE;
+  bool player  = FALSE;
+  bool account = FALSE;
 
   // are we trying to modify a character on disk?
-  if(!strncasecmp(arg, "file ", 5)) {
-    file = TRUE;
-    arg += 5;
+  if(!strncasecmp(arg, "player ", 7)) {
+    player = TRUE;
+    arg   += 7;
+  }
+
+  // are we trying to modify an account?
+  if(!strncasecmp(arg, "account ", 8)) {
+    account = TRUE;
+    arg += 8;
   }
 
   const char *val = two_args(arg, name, field);
 
   // check to see if we're trying to set from our notepad. Also, make sure
   // we have a socket and CAN access our notepad.
-  if(subcmd == SET_SUBCMD_SETPAD) {
+  if(!strcasecmp(cmd, "setpad")) {
     if(charGetSocket(ch) && bufferLength(socketGetNotepad(charGetSocket(ch))))
       val = bufferString(socketGetNotepad(charGetSocket(ch)));
     else {
@@ -156,52 +160,46 @@
     send_to_char(ch, "Set which value on what?\r\n");
 
   // we're trying to set something on someone's pfile
-  else if(file == TRUE) {
+  else if(player == TRUE) {
     // make sure the player isn't online, currently
-    CHAR_DATA *tgt = generic_find(ch, name, FIND_TYPE_CHAR, FIND_SCOPE_ALL, 
-				  FALSE, NULL);
-    if(tgt != NULL)
-      send_to_char(ch, "%s is currently logged on. No need to touch the pfile.\r\n", charGetName(tgt));
+    CHAR_DATA *tgt = get_player(name);
+    if(tgt == NULL)
+      send_to_char(ch, "No pfile for %s exists!\r\n", name);
+    else if(!charHasMoreUserGroups(ch, tgt)) {
+      send_to_char(ch, "Sorry, %s has just as many priviledges as you.\r\n", 
+		   HESHE(tgt));
+      unreference_player(tgt);
+    }
     else {
-      tgt = load_player(name);
-      if(tgt == NULL)
-	send_to_char(ch, "No pfile for %s exists!\r\n", name);
-      else if(!charHasMoreUserGroups(ch, tgt))
-	send_to_char(ch, "Sorry, %s has just as many priviledges as you.\r\n", 
-		     HESHE(tgt));
-      else {
-	try_set(ch, tgt, char_set_table, field, val);
-	save_player(tgt);
-	deleteChar(tgt);
-      }
+      try_set(ch, tgt, char_set_table, field, val);
+      save_player(tgt);
+      unreference_player(tgt);
     }
   }
 
-  // are we trying to set a field on a room?
-  else if(!strcasecmp("room", name)) {
-    if(!canEditZone(worldZoneBounding(gameworld, roomGetVnum(charGetRoom(ch))),
-		    ch))
-      send_to_char(ch, "You are not authorized to edit this zone.\r\n");
-    else
-      try_set(ch, charGetRoom(ch), room_set_table, field, val);
-  }
-
-  // are we trying to set a field on a room, by vnum>
-  else if(isdigit(*name) && worldGetRoom(gameworld, atoi(name))) {
-    if(!canEditZone(worldZoneBounding(gameworld, atoi(name)), ch))
-      send_to_char(ch, "You are not authorized to edit this zone.\r\n");
-    else
-      try_set(ch, worldGetRoom(gameworld, atoi(name)),room_set_table,field,val);
+  // we're trying to edit an account
+  else if(account == TRUE) {
+    ACCOUNT_DATA *tgt = get_account(name);
+    
+    if(tgt == NULL)
+      send_to_char(ch, "No such account exists!\r\n");
+    else {
+      try_set(ch, tgt, acct_set_table, field, val);
+      save_account(tgt);
+      unreference_account(tgt);
+    }
   }
 
   // are we setting a field on an object or character in game?
   else {
     int found = FOUND_NONE;
     void *tgt = NULL;
-    tgt = generic_find(ch, name, FIND_TYPE_CHAR | FIND_TYPE_OBJ,
+    tgt = generic_find(ch, name,FIND_TYPE_CHAR | FIND_TYPE_OBJ | FIND_TYPE_ROOM,
 		       FIND_SCOPE_ALL | FIND_SCOPE_VISIBLE, FALSE, &found);
 
-    if(found == FOUND_CHAR) {
+    if(tgt == NULL)
+      send_to_char(ch, "What was the target you were trying to modify?\r\n");
+    else if(found == FOUND_CHAR) {
       if(ch != tgt && !charHasMoreUserGroups(ch, tgt))
 	send_to_char(ch, "Sorry, %s has just as many priviledges as you.\r\n", 
 		     HESHE(tgt));
@@ -210,8 +208,13 @@
     }
     else if(found == FOUND_OBJ)
       try_set(ch, tgt, obj_set_table, field, val);
-    else
-      send_to_char(ch, "What was the target you were trying to modify?\r\n");
+    else if(found == FOUND_ROOM) {
+      if(!canEditZone(worldGetZone(gameworld,get_key_locale(roomGetClass(tgt))),
+		      ch))
+	send_to_char(ch, "You are not authorized to edit that zone.\r\n");
+      else
+	try_set(ch, tgt, room_set_table, field, val);
+    }
   }
 }
 
@@ -227,6 +230,7 @@
   char_set_table = newHashtable();
   obj_set_table  = newHashtable();
   room_set_table = newHashtable();
+  acct_set_table = newHashtable();
 
   // add in the default sets for the core of the MUD
   /************************************************************/
@@ -245,7 +249,6 @@
   add_set("mrdesc",   SET_CHAR, SET_TYPE_STRING, charSetMultiRdesc,   NULL);
   add_set("mname",    SET_CHAR, SET_TYPE_STRING, charSetMultiName,    NULL);
   add_set("keywords", SET_CHAR, SET_TYPE_STRING, charSetKeywords,     NULL);
-  add_set("dialog",   SET_CHAR, SET_TYPE_INT,    charSetDialog,       NULL);
   add_set("race",     SET_CHAR, SET_TYPE_STRING, charSetRace,       isRace);
   add_set("groups",   SET_CHAR, SET_TYPE_STRING, charSetUserGroups,   NULL);
 
@@ -263,9 +266,9 @@
   add_set("keywords", SET_OBJECT,SET_TYPE_STRING,objSetKeywords,      NULL);
 
   // now, add the admin commands for working with set
-  add_cmd("set", NULL, cmd_set, SET_SUBCMD_SET, POS_UNCONCIOUS, POS_FLYING,
+  add_cmd("set", NULL, cmd_set, POS_UNCONCIOUS, POS_FLYING,
 	  "admin", FALSE, FALSE);
-  add_cmd("setpad", NULL, cmd_set, SET_SUBCMD_SETPAD, POS_UNCONCIOUS,POS_FLYING,
+  add_cmd("setpad", NULL, cmd_set, POS_UNCONCIOUS,POS_FLYING,
 	  "admin", FALSE, FALSE);
 }
 
@@ -273,9 +276,10 @@
 void add_set(const char *name, int set_for, int type, void *setter, void *checker) {
   HASHTABLE *table = NULL;
   // first, find our table
-  if     (set_for == SET_CHAR)   table = char_set_table;
-  else if(set_for == SET_OBJECT) table = obj_set_table;
-  else if(set_for == SET_ROOM)   table = room_set_table;
+  if     (set_for == SET_CHAR)    table = char_set_table;
+  else if(set_for == SET_OBJECT)  table = obj_set_table;
+  else if(set_for == SET_ROOM)    table = room_set_table;
+  else if(set_for == SET_ACCOUNT) table = acct_set_table;
 
   // if there was no table, we can't do anything
   if(table == NULL) return;
